import math, vector
from vector import *




       
class Centroid:
    def __init__(self, pos=(0,0), mass=1, friction=0, damping=0.9, k=1, breaking=500):
        self.x = pos
        self.dx = vzeros(2)
        self.ddx = vzeros(2)        
        self.mass = mass
        self.friction = friction
        self.damping = damping
        self.k = k
        self.breaking = breaking
        self.targets = []
        self.free = False

        
    
    def set_targets(self, targets):
        self.targets = targets
                
    def integrate(self, dt):              
        self.ddx = vzeros(2)
        
        for target in self.targets:        
            dx = vsub(target, self.x)
            ldx = vlength(dx)
            normed = vnormalize(dx)            
            if ldx<self.breaking:                
                self.ddx = vadd(self.ddx, vscale(dx, -self.k))
            
                
                
        
        self.ddx = vadd(self.ddx, vscale(self.dx, -self.friction))
        self.dx = vscale(vadd(self.dx, vscale(self.ddx, dt)), self.damping)
        self.x = vadd(self.x, vscale(self.dx, dt))
        
        
        
    