
import math, geometry, random
from geometry import to_radians, to_degrees
import vector
from vector import *


class Model:
        def __init__(self, steps, prob):
            self.step = 0
            self.steps = steps
            self.prob = prob
            
            
        def next(self):
            self.step = self.step+1
            if self.step%self.steps==0:
                return random.random()<self.prob
            else:
                return False    
                
        def __call__(self, *args, **kwargs):
            return self.next()

def quantized_exponential_model(steps, prob):               
    return Model(steps, prob)
    
    
def exponential_model(prob):
    return quantized_exponential_model(1, prob)
                
def quantized_model(steps):
    return quantized_exponential_model(steps, 1)
    
       
def gaussian_distribution(var):
    return lambda: random.gauss(0, var)
       
def uniform_distribution(width):
    return lambda: random.randrange(-width, width)
    
def uniform_range_distribution(start, end):
    return lambda: random.randrange(start, end)
    
def constant_distribution(x):
    return lambda: x
        
