
import math, geometry, random

from geometry import to_radians, to_degrees

import vector
from vector import *



class ObstaclePolygon:
    
    # represent an obstacle as a polygon
    def __init__(self, pts):
        self.pts = pts
        self.lines = []
        old = None
        for pt in pts:
            if old!=None:
                self.lines.append([pt,old])
            old = pt           
        self.lines.append([pts[0], pts[-1]])
        
            
    def inside(self, pt):
        # return true if pt is inside the polygon.
        # assuming that it is convex, of course...
        
        return geometry.inside_polygon(pt, self.pts)
        
        # sum = reduce(vadd,self.pts)
        # centroid = vscale(sum, 1.0/len(self.pts))        
        # for i in range(len(self.pts)-1):            
            # if geometry.inside_triangle(pt,[centroid, self.pts[i], self.pts[i+1]]):
                # return True
        # return False
        
        
        
        
        
    def intersect(self, start, end):
        
        # intersect the line from start to end with each line in the geometry
        # then find the direction with the biggest dot product
        # this is the direction closest to the direction we are already heading in        
        for line in self.lines:           
            # check interesections (both ways, lines are solid from both sides!)
            
            aside = geometry.line_intersect(start,end, line[0], line[1])
            bside = geometry.line_intersect(end,start, line[0], line[1])
            
            # if intersect, compute dot product, return best fitting direction
            if aside or bside:
                adir = vnormalize(vsub(line[0], line[1]))
                bdir = vnormalize(vsub(line[1], line[0]))
                
                adp = vdotproduct(adir, vsub(start, end))
                bdp = vdotproduct(bdir, vsub(start,end))
                
                #adp = vdotproduct(adir, normal)
                #bdp = vdotproduct(bdir, normal)
                if adp<bdp:
                    return bdir
                else:
                    return adir                                                               
        return None
                
                